"use strict";

this.name    = "Auto Crosshairs";
this.version = "1.1";

/* ====================================================================================
			OTHER SCRIPTS CAN SAFELY TWIDDLE THIS AT ANY TIME...
======================================================================================= */

this.$precision = 2; // Whole number 1-5

/* ====================================================================================
			STARTING & STOPPING FRAME CALLBACK
======================================================================================= */

    this.shipTargetAcquired = function (target) {
        "use strict";
        if (player.ship.equipmentStatus("EQ_AUTO_CROSSHAIRS") === "EQUIPMENT_OK") {
            if (this.$crosshairs[player.ship.hud]) {
                this.$onTargetCrosshairs  = this.$crosshairs[player.ship.hud].on;
                this.$offTargetCrosshairs = this.$crosshairs[player.ship.hud].off;
            } else {
                this.$onTargetCrosshairs  = this.$crosshairs.default.on;
                this.$offTargetCrosshairs = this.$crosshairs.default.off;
            //    if (player.ship.crosshairs != this.$onTargetCrosshairs) {
            //        this.$offTargetCrosshairs = player.ship.crosshairs;
            //    }
            }
            if (this.$offTargetCrosshairs === null) {
                this.$ooliteQuirk = [
                    player.ship.reticleTargetSensitive,
                    player.ship.scannerNonLinear,
                    player.ship.scannerUltraZoom
                ];
            }
            this.$runningFCB = addFrameCallback(this._targetAlert.bind(this));
        }
    }

    this._ooliteQuirk = function () {
        "use strict";
        player.ship.reticleTargetSensitive = this.$ooliteQuirk[0];
        player.ship.scannerNonLinear = this.$ooliteQuirk[1];
        player.ship.scannerUltraZoom = this.$ooliteQuirk[2];
    }

    this.shipWillDockWithStation = this.shipWillEnterWitchspace = this.shipDied = function () {
        "use strict";
        this._removeFCB();
    }

    this.equipmentDamaged = this.equipmentDestroyed = function (equipment) {
        "use strict";
        if (equipment === "EQ_AUTO_CROSSHAIRS") {
            this._removeFCB();
        }
    }

    this._removeFCB = function () {
        "use strict";
        if (this.$runningFCB) {
            removeFrameCallback(this.$runningFCB);
            delete this.$runningFCB;
            delete this.$currentState;
            player.ship.crosshairs = this.$offTargetCrosshairs;
            if (this.$ooliteQuirk) {
                this._ooliteQuirk();
                delete this.$ooliteQuirk;
            }
        }
    }

/* ====================================================================================
			TARGET SENSITIVITY (FRAME CALLBACK)
======================================================================================= */

    this._targetAlert = function () {
        "use strict";
        var self = player.ship;
        if (self.target) {
            var target = self.target;
            var range  = target.position.distanceTo(self.position) - target.collisionRadius;
            var deviation;
            switch (self.viewDirection) {
                case "VIEW_FORWARD":   deviation = self.vectorForward.angleTo(target.position.subtract(self.position)) * range; break;
                case "VIEW_AFT":       deviation = self.vectorForward.angleTo(self.position.subtract(target.position)) * range; break;
                case "VIEW_PORT":      deviation = self.vectorRight.angleTo(self.position.subtract(target.position)) * range;   break;
                case "VIEW_STARBOARD": deviation = self.vectorRight.angleTo(target.position.subtract(self.position)) * range;   break;
                default:               deviation = self.vectorForward.angleTo(target.position.subtract(self.position)) * range; // forward
            }
            if (deviation < target.collisionRadius / this.$precision) {
                if (this.$currentState === "ON_TARGET") {
                    return;
                }
                player.ship.crosshairs = this.$onTargetCrosshairs;
                this.$currentState = "ON_TARGET";
                return;
            } else {
                if (this.$currentState === "OFF_TARGET") {
                    return;
                }
                player.ship.crosshairs = this.$offTargetCrosshairs;
                if (this.$ooliteQuirk) {
                    this._ooliteQuirk();
                }
                this.$currentState = "OFF_TARGET";
                return;
            }
        } else { // If player.ship.target is gone.
            this._removeFCB();
        }
    }

/* ====================================================================================
			SCAN FOR SPECIAL HUDs AT STARTUP...
======================================================================================= */

    this.startUpComplete = function () {
        "use strict";
        if (!this.$crosshairs) {
            this.$crosshairs = {default: {off: null, on: "auto-crosshairs-on-target.plist"}};
        }
        var scriptName;
        var arrayLength = worldScriptNames.length;
        for (var i = 0; i < arrayLength; i++) {
            scriptName = worldScriptNames[i];
            if (worldScripts[scriptName].$autoCrosshairs) {
                var definition = worldScripts[scriptName].$autoCrosshairs;
                for (prop in definition) {
                    this.$crosshairs[prop] = {};
                    this.$crosshairs[prop].off = definition[prop].off;
                    this.$crosshairs[prop].on = definition[prop].on;
                }
            }
        }
        delete this.startUpComplete;
    }

/* ====================================================================================
			COPYRIGHT NOTICE

	(C) 2013,2014 Wildeblood. All rights reserved. 
	Free to use, but DO NOT PROMULGATE MODIFIED VERSIONS.

This was created by some fellow with the user name "Wildeblood" on the Oolite forums, 
he'll tell you his real name if you bother to ask.
To use means to play with, modify or re-use in whole or in part, and to distribute freely.
To use DOES NOT imply to use for commercial gain, which would be a breach of copyright.
To promulgate means to make official announcements.
======================================================================================= */